<?php
/**
 * Класс для скачивания чего попало из интернета
 *
 */
class Retriever {
	/**
	 * URL файла который скачать
	 *
	 * @var string
	 */
	var $remote_file;
	/**
	 * Имя файла в который сохранить
	 *
	 * @var string
	 */
	var $local_file;
	/**
	 * Удаленный хост
	 *
	 * @var string
	 */
	var $host;
	/**
	 * Путь на удаленном сервере
	 *
	 * @var string
	 */
	var $path;
	/**
	 * Содержимое полученного файла
	 *
	 * @var string
	 */
	var $content;
	/**
	 * Реферер
	 *
	 * @var string
	 */
	var $refer;

	/**
	 * Конструктор
	 *
	 * @param string $remote_file
	 * @param string $local_file
	 * @return Retriever
	 */
	function Retriever($remote_file, $local_file, $refer) {
		$this->remote_file = $remote_file;
		$this->local_file = $local_file;
		$this->refer = $refer;

		$parts = preg_match("@^http://(.+)/(.+)$@Uis", $this->remote_file, $matches);

		$this->host = $matches[1];
		$this->path = "/" . $matches[2];
	}

	/**
	 * Скачивает файл и сохраняет его на диске
	 *
	 */
	function fetch() {

		$user_agent = 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.9) Gecko/20071025 Firefox/2.0.0.9';

		@ini_set('default_socket_timeout', 15);
		@ini_set('user_agent', $user_agent);

		// через курл
		if (function_exists('curl_init')) {
			if ($c = @curl_init()) {

				@curl_setopt($c, CURLOPT_URL, $this->remote_file);
				@curl_setopt($c, CURLOPT_HEADER, false);
				@curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
				@curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 15);
				@curl_setopt($c, CURLOPT_USERAGENT, $user_agent);
				@curl_setopt($c, CURLOPT_REFERER, $this->refer);
				@curl_setopt($c, CURLOPT_FOLLOWLOCATION, 1);

				$text = @curl_exec($c);

				@curl_close($c);
			}
			// самый плохой путь
		} else {
			$buff = '';
			$fp = @fsockopen($this->host, 80, $errno, $errstr, 15);
			if ($fp) {
				@fputs($fp, "GET " . $this->path . " HTTP/1.0\r\nHost: " . $this->host . "\r\n");
				@fputs($fp, "User-Agent: " . $user_agent . "\r\n\r\n");
				@fputs($fp, "Referer: " . $this->refer . "\r\n\r\n");
				while (!@feof($fp)) {
					$buff .= @fgets($fp, 1024);
				}
				@fclose($fp);
				$page = explode("\r\n\r\n", $buff);
				$text = $page[1];
			}
		}

		$this->content = $text;
	}

	/**
	 * Возвращает содержимое, полученное от сервера
	 *
	 * @return string
	 */
	function get_content() {
		return $this->content;
	}

	/**
	 * Записать полученное содержимое в файл
	 *
	 */
	function save() {
		$fh = @fopen($this->local_file, "w");
		if (is_resource($fh)) {
			@fputs($fh, $this->get_content());
		}
		@fclose($fh);
		chmod($this->local_file, 0666);
	}

	/**
	 * Устанавливает время модификации локального файла
	 *
	 * @param int $diff
	 */
	function touch($diff = 0) {
		@touch($this->local_file, time() + $diff);
	}

	/**
	 * Возвращает true или false в зависимости от того, считается ли файл устаревшим
	 *
	 * @param int $timeout количество секунд, после которого считать файл устаревшим
	 * @return boolean
	 */
	function is_old($timeout) {

		if ($timeout < 3600) {
			$timeout = 3600;
		}

		if (file_exists($this->local_file)) {
			$stat = stat($this->local_file);
			$mtime = $stat[9];
			return (time() - $mtime > $timeout);
		} else {
			return true;
		}
	}

	/**
	 * Получить содержимое файла
	 *
	 * @return string
	 */
	function get_contens() {
		if (file_exists($this->local_file)) {
			return @implode("", file($this->local_file));
		} else {
			return null;
		}
	}
}
?>