<?php
$sengine = array();
$sengine[] = array('name' => 'Amazon', 'url' => 'amazon.com', 'host' => 'amazon', 'query_field' => 'k');
$sengine[] = array('name' => 'AOL_COM', 'url' => 'aol.com', 'host' => 'search.aol.com', 'query_field' => 'q');
$sengine[] = array('name' => 'AOL_DE', 'url' => 'aol.de', 'host' => 'suche.aol.de', 'query_field' => 'q');
$sengine[] = array('name' => 'Ask', 'url' => 'ask.com', 'host' => 'ask.com', 'query_field' => 'q');
$sengine[] = array('name' => 'Baidu', 'url' => 'baidu.com', 'host' => 'baidu.com', 'query_field' => 'wd');
$sengine[] = array('name' => 'Bigmir_RU', 'url' => 'bigmir.net', 'host' => 'search.bigmir.net', 'query_field' => 'z');
$sengine[] = array('name' => 'Bing', 'url' => 'bing.com', 'host' => 'bing.com', 'query_field' => 'q');
$sengine[] = array('name' => 'DuckDuckGo', 'url' => 'duckduckgo.com', 'host' => 'duckduckgo.com', 'query_field' => 'q');
$sengine[] = array('name' => 'Facebook', 'url' => 'facebook.com', 'host' => 'facebook.com', 'query_field' => 'q');
$sengine[] = array('name' => 'Fireball_COM', 'url' => 'fireball.com', 'host' => 'fireball.com', 'query_field' => 'query');
$sengine[] = array('name' => 'Google', 'url' => 'google.com', 'host' => 'google', 'query_field' => 'q');
$sengine[] = array('name' => 'Google-Blogsearch', 'url' => 'blogsearch.google.', 'host' => 'blogsearch.google.com', 'query_field' => 'q');
$sengine[] = array('name' => 'I_UA', 'url' => 'search.i.ua', 'host' => 'search.i.ua', 'query_field' => 'q');
$sengine[] = array('name' => 'LookSmart', 'url' => 'looksmart.com', 'host' => 'search.looksmart.com', 'query_field' => 'q');
$sengine[] = array('name' => 'Lycos-Com', 'url' => 'lycos.com', 'host' => 'search.lycos.com', 'query_field' => 'q');
$sengine[] = array('name' => 'M.Yandex_RU', 'url' => 'm.yandex.ru', 'host' => 'm.yandex.ru', 'query_field' => 'query');
$sengine[] = array('name' => 'Mail_RU', 'url' => 'mail.ru', 'host' => 'go.mail.ru', 'query_field' => 'q');
$sengine[] = array('name' => 'Meta_UA', 'url' => 'meta.ua', 'host' => 'meta.ua', 'query_field' => 'q');
$sengine[] = array('name' => 'MSN_COM', 'url' => 'search.msn.com', 'host' => 'search.msn.', 'query_field' => 'q');
$sengine[] = array('name' => 'Rambler_RU', 'url' => 'rambler.ru', 'host' => 'rambler.ru', 'query_field' => 'query');
$sengine[] = array('name' => 'Seznam_CZ', 'url' => 'seznam.cz', 'host' => 'search.seznam.cz', 'query_field' => 'q');
$sengine[] = array('name' => 'Twitter', 'url' => 'twitter.com', 'host' => 'twitter.com', 'query_field' => 'q');
$sengine[] = array('name' => 'Web-De', 'url' => 'web.de', 'host' => 'suche.web.de', 'query_field' => 'q');
$sengine[] = array('name' => 'Webalta_RU', 'url' => 'webalta.ru', 'host' => 'webalta.', 'query_field' => 'q');
$sengine[] = array('name' => 'Yahoo_COM', 'url' => 'yahoo.com', 'host' => 'yahoo.com', 'query_field' => 'p');
$sengine[] = array('name' => 'Yandex_RU', 'url' => 'yandex.ru', 'host' => 'yandex.ru', 'query_field' => 'text');
$sengine[] = array('name' => 'YouTube', 'url' => 'youtube.com', 'host' => 'youtube.com', 'query_field' => 'search_query');

function getInfo($url) {
	global $sengine;

	$url = utf8_to_cp1251(htmlspecialchars_decode_(urldecode($url)));
	// no search engines in the db? then no need to search ...
	if (!is_array($sengine)) {
		return false;
	}

	$url_info = parse_url($url); // parse the url

	// check each search engine in the database
	foreach ($sengine as $se) {
		// if the host of the search engine matches
		// the one of the url we have successfully
		// located the search engine
		if (stristr($url, $se['host'])) {
			// parse the query
			parse_str($url_info['query'], $query_info);
			// return all information
			if (empty($query_info[$se['query_field']])) {
				$sq = $se['query_field'];
				$regexp = "#^.*\?" . $sq . "=(.*?)[&]{0,1}.*$#is";
				preg_match($regexp, $url, $rrr);
				$query_info[$se['query_field']] = $rrr[1];
			}

			$rez = array('sengine_name' => $se['name'],
				'sengine_url' => $se['url'],
				'query' => $query_info[$se['query_field']],
				'url' => $url);
			return $rez;
		}
	}
	// if no search engine was found return false
	return false;
}

?>