<?php
/**
 *     sTDS MOD JackSoft
 *
 */

class SimpleTdsRouteCryptor {

	private $_maxRand;

	private $_cached = array();

	private $_hashLength;

	/**
	 * 
	 *
	 * @param int $maxRand    .  ,  
	 * @param int $hashLength  .   15
	 */
	function __construct($maxRand = 0, $hashLength = 32) {
		$this->_maxRand = $maxRand;
		if ($hashLength < 15) {
			die('hash length must be >15');
		}

		$this->_hashLength = $hashLength;
	}

	/**
	 *   
	 *
	 * @param string $tdsUrl    ,     
	 * @return string
	 */
	function cryptTdsRoute($tdsUrl) {
		if ($this->_maxRand != 0 && count($this->_cached) >= $this->_maxRand) {
			$rand = mt_rand(0, $this->_maxRand - 1);
			return $this->_cached[$rand];
		}

		$split = explode('go.php?sid=', $tdsUrl);

		if (count($split) != 2) {
			die('invalid tds url' . $tdsUrl);
		}

		$cryptoUrl = $split[0] . 'to/';

		$hash = $this->_cryptSID(trim($split[1]));
		$cryptoUrl .= $hash;

		$cryptoUrl .= '/';

		$this->_cached[] = $cryptoUrl;

		return $cryptoUrl;
	}

	private function _cryptSID($sid) {
		$hashA = $this->_createEmptyHash($sid);
		$hash = $this->_createHash($hashA);
		return $hash;
	}

	private function _createEmptyHash($id) {
		$hash = array_fill(0, 32, null);

		$numbers = array_keys($hash);

		shuffle($numbers);

		$digitIndexList = array_splice($numbers, 0, strlen($id));

		sort($digitIndexList);

		for ($i = 0; $i < count($digitIndexList); $i++) {
			$hash[$digitIndexList[$i]] = $id[$i];
		}

		return $hash;
	}

	private function _createHash($hashA) {
		$alpha = 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz';
		for ($i = 0; $i < count($hashA); $i++) {
			if (!empty($hashA[$i])) {
				continue;
			}

			$rand = mt_rand(0, strlen($alpha) - 1);
			$hashA[$i] = $alpha[$rand];
		}
		return join('', $hashA);
	}

}
